C***********************************************************************0001.000
C        S.UTILPLOT : utility library for HP7550 plotter                0002.000
C                     required by AIMPAC package                        0003.000
C
C        written by Carlo Gatti and Mario Barzaghi , february 1987
                                                                        0004.000
C        subroutines included :   PLOT                                  0005.000
C                                 PLT_Init
C                                 PLT_End
C                                 LETTER                                0007.000
C                                 OCAREA                                0008.000
C                                 WINDOW                                0009.000
C                                 NEWPEN                                0010.000
C                                                                       0011.000
C        september 92: added PLT_INLASER
C***********************************************************************0012.000
C     ------------------------------------------------------------------
      Subroutine PLT_Init (IOut)
C     ------------------------------------------------------------------
      Write (IOut,'(''DF;PA;RO;WD'',A1,'';KY;CV;SP1;'')') Char(3)
      Return
      End
C     ------------------------------------------------------------------0020.000
C     ------------------------------------------------------------------
      Subroutine PLT_Inlaser (IOut)
C     ------------------------------------------------------------------
      write(iout,*) 
     *             ' E'
      write(iout,*) 
     *            ' &l1O'
      write(iout,*) 
     *            ' %0B'
      Write (IOut,'(''DF;PA;RO;WD'',A1,'';KY;CV;SP1;'')') Char(3)
      Return
      End
C     ------------------------------------------------------------------0020.000
      Subroutine PLT_End (IOut)                                         0021.000
C     ------------------------------------------------------------------0022.000
      Write(IOut,'(''SP0;NR;'')')                                       0023.000
      Return                                                            0024.000
      End                                                               0025.000
C     ------------------------------------------------------------------0026.000
C     ------------------------------------------------------------------0020.000
      Subroutine PLT_EndLaser (IOut)                                         0021.000
C     ------------------------------------------------------------------0022.000
      Write(IOut,'(''SP0;NR;'')')                                       0023.000
      write(iout,*) 
     *             '%0A'
      write(iout,*) 
     *             '&l0H'
      write(iout,*) 
     *             'E'
      Return                                                            0024.000
      End                                                               0025.000
C     ------------------------------------------------------------------0026.000
                                                                        0027.000
      SUBROUTINE PLOT(X,Y,N)                                            0028.000
C     ------------------------------------------------------------------0029.000
      REAL*8 X,Y                                                        0030.000
      COMMON /HP7550/ IOUT                                              0031.000
C                                                                       0032.000
      IF (N.EQ.2) THEN                                                  0033.000
         WRITE(IOUT,'(2HPD,F6.3,1H,,F6.3,1H;)') X,Y                     0034.000
      ELSE                                                              0035.000
         WRITE(IOUT,'(2HPU,F6.3,1H,,F6.3,1H;)') X,Y                     0036.000
      END IF                                                            0037.000
C                                                                       0038.000
      RETURN                                                            0039.000
      END                                                               0040.000
                                                                        0041.000
C     ------------------------------------------------------------------0058.000
      SUBROUTINE PTHICK(PTH)
C     ------------------------------------------------------------------0058.000
      REAL*8 PTH
      COMMON /HP7550/ IOUT                                              0031.000
C
      IF(PTH.LT.5.) THEN
      WRITE(IOUT,'(2HPW,1H ,F6.3,1H;)')PTH
      ELSE
      WRITE (6,*) 'STOP: DECREASE PEN THICKNESS'
      STOP  
      ENDIF
      RETURN
      END
C     ------------------------------------------------------------------0058.000
      SUBROUTINE LETTER (N,HEIGHT,WIDTH,ANG,X,Y,STRING)                 0059.000
C     ------------------------------------------------------------------0060.000
C                                                                       0061.000
C     N      = NUMBER OF CHARACTERS IN 'STRING' (N =< 80)               0062.000
C     HEIGHT = HEIGHT OF CHARACTER IN CENTIMETERS                       0063.000
C     WIDTH  = WIDTH OF CHARACTER IN CENTIMETERS                        0064.000
C     ANG    = ANGLE TO X AXIS IN DEGREES                               0065.000
C     X,Y    = X AND Y COORDINATES IN USER UNITS                        0066.000
C     STRING = HOLLERITH STRING                                         0067.000
C                                                                       0068.000
C     ------------------------------------------------------------------0069.000
      REAL*8  HEIGHT,WIDTH,ANG,X,Y,TORAD,COSA,SINA                      0070.000
      CHARACTER*80 BUFF                                                 0071.000
      INTEGER*4 STRING(1)                                               0072.000
      CHARACTER*1 TERM                                                  0073.000
      PARAMETER (TORAD=3.1415926536/180.)                               0074.000
      COMMON /HP7550/ IOUT                                              0075.000
C                                                                       0076.000
      BUFF(1:80)=' '
      COSA=DCOS(ANG*TORAD)                                              0077.000
      SINA=DSIN(ANG*TORAD)                                              0078.000
      TERM=CHAR(3)                                                      0084.000
      WRITE(IOUT,'(2HLB,A1)') TERM
      WRITE(IOUT,'(2HPU,F20.10,1H,,F20.10,1H;)') X,Y                    0079.000
      WRITE(BUFF,'(2HSI,F10.5,1H,,F10.5,1H;)') WIDTH,HEIGHT             0080.000
      WRITE(IOUT,'(A80)') BUFF                                          0081.000
      WRITE(BUFF,'(2HDI,F10.6,1H,,F10.6,1H;)') COSA,SINA                0082.000
      WRITE(IOUT,'(A80)') BUFF                                          0083.000
      NN=(N+3)/4                                                        0085.000
      WRITE(BUFF,'(20A4)') (STRING(I),I=1,NN)                           0086.000
      WRITE(IOUT,'(3HLB ,A,A1,1H;)') BUFF(1:76),TERM 
      RETURN                                                            0088.000
      END                                                               0089.000
                                                                        0090.000
C     ------------------------------------------------------------------0091.000
      SUBROUTINE OCAREA (XMIN,XMAX,YMIN,YMAX,SIZE,IOUT,SX,SY)           0092.000
C     ------------------------------------------------------------------0093.000
C                                                                       0094.000
C     Definisce l'area utente in modo da avere coordinate               0095.000
C     omogenee su X e Y.                                                0096.000
C                                                                       0097.000
C     Input:                                                            0098.000
C                                                                       0099.000
C     XMIN   valore inferiore di X in coordinate utente                 0100.000
C     XMAX   valore superiore di X in coordinate utente                 0101.000
C     YMIN   valore inferiore di Y in coordinate utente                 0102.000
C     YMAX   valore superiore di Y in coordinate utente                 0103.000
C            ( per Schuss e Plotden sono in cm. )                       0104.000
C     SIZE   formato del foglio (A3 o A4)                               0105.000
C     IOUT   unita' fortran per il plotter                              0106.000
C                                                                       0107.000
C     Output:                                                           0108.000
C                                                                       0109.000
C     SX     converte la coordinata utente lungo X in centimetri        0110.000
C     SY     converte la coordinata utente lungo Y in centimetri        0111.000
C                                                                       0112.000
C     ------------------------------------------------------------------0113.000
      IMPLICIT REAL*8(A-H,O-Z)                                          0114.000
      CHARACTER*2   SIZE                                                0115.000
C                                                                       0116.000
      PARAMETER ( POINTS=.025 )  ! punto grafico in mm. ( 40 x  1 mm )  0117.000
      PARAMETER ( PCM   =400.  ) ! numero di punti grafici per cm       0118.000
C                                                                       0119.000
C     Dimensioni del foglio A4  in punti grafici:                       0120.000
C                                                                       0121.000
      PARAMETER( LA4X=10870 , LA4Y=7600 ,                               0122.000
     .           MA4L=1000  , ! margine sinistro                        0123.000
     .           MA4R=300   , ! margine destro                          0124.000
     .           MA4D=500   , ! margine inferiore                       0125.000
     .           MA4U=500   ) ! margine superiore                       0126.000
C                                                                       0127.000
C     Dimensioni del foglio A3  in punti grafici:                       0128.000
C                                                                       0129.000
      PARAMETER( LA3X=15970 , LA3Y=10870 ,                              0130.000
     .           MA3L=1750  , ! margine sinistro                        0131.000
     .           MA3R=450   , ! margine destro                          0132.000
     .           MA3D=750   , ! margine inferiore                       0133.000
     .           MA3U=910   ) ! margine superiore                       0134.000
C                                                                       0135.000
C     Definizione della pagina per il formato A4 o A3                   0136.000
C                                                                       0137.000
      IF (SIZE.EQ.'A4') THEN                                            0138.000
        IP1X=MA4L                                                       0139.000
        IP1Y=MA4D                                                       0140.000
        IP2X=LA4X-MA4R                                                  0141.000
        IP2Y=LA4Y-MA4U                                                  0142.000
      ELSE                                                              0143.000
        IP1X=MA3L                                                       0144.000
        IP1Y=MA3D                                                       0145.000
        IP2X=LA3X-MA3R                                                  0146.000
        IP2Y=LA3Y-MA3U                                                  0147.000
      ENDIF                                                             0148.000
C                                                                       0149.000
C     Se il disegno e' allungato lungo Y ruota il foglio                0150.000
C                                                                       0151.000
      IF (DABS(YMAX-YMIN).GT.DABS(XMAX-XMIN))   THEN                    0152.000
        WRITE(IOUT,'(''RO90;IP;'')')                                    0153.000
        L=IP2X                                                          0154.000
        IP2X=IP2Y                                                       0155.000
        IP2Y=L                                                          0156.000
      ENDIF                                                             0157.000
C                                                                       0158.000
C     Arrotonda i valori massimi all'intero superiore e i valori        0159.000
C     minimi all'intero inferiore.                                      0160.000
      XMX=DINT(XMAX)                                                    0161.000
      IF(XMAX.GT.XMX)  XMX=XMX+1.D00                                    0162.000
      XMN=DINT(XMIN)                                                    0163.000
      YMX=DINT(YMAX)                                                    0164.000
      IF(YMAX.GT.YMX)  YMX=YMX+1.D00                                    0165.000
      YMN=DINT(YMIN)                                                    0166.000
C                                                                       0167.000
C     Definizione della scala                                           0168.000
C                                                                       0169.000
      DELTAX=XMX-XMN                                                    0170.000
      DELTAY=YMX-YMN                                                    0171.000
      LATOX=DELTAX*PCM                                                  0172.000
      LATOY=DELTAY*PCM                                                  0173.000
      RPAGE=DBLE(LATOX)/DBLE(LATOY)                                     0174.000
C                                                                       0175.000
      IF(DABS(DELTAX)/DABS(DELTAY).LE.RPAGE) THEN                       0176.000
         IP2X=IP1X+LATOY                                                0177.000
         IP2Y=IP1Y+LATOY                                                0178.000
         X=XMN+DELTAY                                                   0179.000
         WRITE(IOUT,'(2HIP,4(1X,I5),3H;SC,4F8.0,1H;)')                  0180.000
     .   IP1X,IP1Y,IP2X,IP2Y, XMN,X,YMN,YMX                             0181.000
      ELSE                                                              0182.000
         IP2X=IP1X+LATOX                                                0183.000
         IP2Y=IP1Y+LATOX                                                0184.000
         Y=YMN+DELTAX                                                   0185.000
         WRITE(IOUT,'(2HIP,4(1X,I5),3H;SC,4F8.0,1H;)')                  0186.000
     .   IP1X,IP1Y,IP2X,IP2Y, XMN,XMX,YMN,Y                             0187.000
      ENDIF                                                             0188.000
C                                                                       0189.000
C     Calcola il valore del punto grafico in coordinate utente lungo    0190.000
C     gli assi X e Y                                                    0191.000
C                                                                       0192.000
      RESX = ( XMX - XMN ) / DBLE ( IP2X - IP1X )                       0193.000
      RESY = ( YMX - YMN ) / DBLE ( IP2Y - IP1Y )                       0194.000
C                                                                       0195.000
C     Calcola il fattore di conversione in centimetri delle             0196.000
C     coordinate utente lungo X e Y                                     0197.000
C                                                                       0198.000
      SX = 0.1D0 * POINTS / RESX                                        0199.000
      SY = 0.1D0 * POINTS / RESY                                        0200.000
C                                                                       0201.000
      RETURN                                                            0202.000
      END                                                               0203.000
                                                                        0204.000
C     ------------------------------------------------------------------0205.000
      SUBROUTINE WINDOW (XMIN,XMAX,YMIN,YMAX,IOUT)                      0206.000
C     ------------------------------------------------------------------0207.000
C                                                                       0208.000
C     Definisce la 'finestra' ove e' possibile plottare.                0209.000
C                                                                       0210.000
C     XMIN   valore inferiore di X in coordinate utente                 0211.000
C     XMAX   valore superiore di X in coordinate utente                 0212.000
C     YMIN   valore inferiore di Y in coordinate utente                 0213.000
C     YMAX   valore superiore di Y in coordinate utente                 0214.000
C     IOUT   unita' fortran per il plotter                              0215.000
C                                                                       0216.000
C     ------------------------------------------------------------------0217.000
      IMPLICIT REAL*8(A-H,O-Z)                                          0218.000
C                                                                       0219.000
C     Arrotonda i valori massimi all'intero superiore e i valori        0220.000
C     minimi all'intero inferiore.                                      0221.000
      XMX=DINT(XMAX)                                                    0222.000
      IF(XMAX.GT.XMX)  XMX=XMX+1.D00                                    0223.000
      XMN=DINT(XMIN)                                                    0224.000
      YMX=DINT(YMAX)                                                    0225.000
      IF(YMAX.GT.YMX)  YMX=YMX+1.D00                                    0226.000
      YMN=DINT(YMIN)                                                    0227.000
C                                                                       0228.000
C     Definisce window                                                  0229.000
C                                                                       0230.000
C     WRITE(IOUT,'(2HIW,3(F8.3,1H,),F8.3,1H;)') XMN,YMN , XMX,YMX       0231.000
C     modified for p2dcrynew.f (CGATTI june 94)
      WRITE(IOUT,'(2HIW,3(F8.3,1H,),F8.3,1H;)') XMIN,YMIN,XMAX,YMAX 
C                                                                       0232.000
      RETURN                                                            0233.000
      END                                                               0234.000
C     ----------------------------------------------------------------- 0235.000
      SUBROUTINE NEWPEN(I)                                              0236.000
C     ----------------------------------------------------------------- 0237.000
                                                                        0238.000
C     select pen number i                                               0239.000
                                                                        0240.000
      COMMON /HP7550/ IOUT                                              0241.000
                                                                        0242.000
      WRITE(IOUT,'(2HSP,I5,1H;)') I                                     0243.000
      RETURN                                                            0244.000
      END                                                               0245.000
C                                                                       0246.000




